/* Lips of Suna
 * Copyright© 2007-2011 Lips of Suna development team.
 *
 * Lips of Suna is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * Lips of Suna is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Lips of Suna. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __ARCHIVE_PACKET_H__
#define __ARCHIVE_PACKET_H__

#include "lipsofsuna/system.h"
#include "archive-reader.h"
#include "archive-writer.h"

typedef struct _LIArcPacket LIArcPacket;
struct _LIArcPacket
{
	char* buffer;
	LIArcReader* reader;
	LIArcWriter* writer;
};

LIAPICALL (LIArcPacket*, liarc_packet_new_readable, (const char* buffer, int length));
LIAPICALL (LIArcPacket*, liarc_packet_new_writable, (int type));
LIAPICALL (void, liarc_packet_free, (LIArcPacket* self));

#endif
